/***********************************************************************
* cpiud332.h
*
* CPI-UD332 Windows API
* Copyright (C) CPI Technologies, Inc.
***********************************************************************/

#ifndef CPIUD332_H      /*[*/
#define CPIUD332_H      1

#ifdef __cplusplus
extern  "C"
{
#endif

/*-----------------------------------------------------------------
// G[R[h
//---------------------------------------------------------------*/
#define UD332_SUCCESS                   0   /* I*/
                                            /* Windows G[ */
#define UD332_ERR_SYSTEM                1   /* GetLastError R[ */
#define UD332_ERR_NO_DEVICE             2   /* gp\ȃfoCXȂ */
#define UD332_ERR_IN_USE                3   /* wfoCX͎gpł */
#define UD332_ERR_INVALID_DEVICENO      4   /* Ș_foCXԍ */
#define UD332_ERR_INVALID_ARGUMENT      5   /* Ȉ */
#define UD332_ERR_INVALID_PORT          6   /* Ș_|[g */
                                            /* DLL [hs */
#define UD332_ERR_DLL                   ( ~0UL )

/*-----------------------------------------------------------------
// ̑
//---------------------------------------------------------------*/
#define UD332_MAX_DEVICES               16
#define UD332_DEVICE_AUTO               ( ( unsigned short )~0 )

/*-----------------------------------------------------------------
// _|[gԍ
//---------------------------------------------------------------*/
#define UD332_PORT_A                    0
#define UD332_PORT_B                    1
#define UD332_PORT_C                    2
#define UD332_PORT_D                    3
#define UD332_MAX_PORTS                 4

/*-----------------------------------------------------------------
// jbg^Cv
//---------------------------------------------------------------*/
#define TYPE_ZD132			1
#define TYPE_ZD232			2
#define TYPE_ZD332			3
#define TYPE_UD132			9
#define TYPE_UD232			10
#define TYPE_UD332			11

/*-----------------------------------------------------------------
// EIb`hbNC^[o萔
//---------------------------------------------------------------*/
#define UD332_WDT_INTERVAL_STOP         0
#define UD332_WDT_INTERVAL_126          1
#define UD332_WDT_INTERVAL_252          2
#define UD332_WDT_INTERVAL_504          3
#define UD332_WDT_INTERVAL_1008         4
#define UD332_WDT_INTERVAL_2016         5

/*-----------------------------------------------------------------
// EIb`hbNJE^̏
//---------------------------------------------------------------*/
#define UD332_WDT_FLAG_OFF              0    /* EIb`hbN܂́ANO */
#define UD332_WDT_FLAG_ON               1    /* EIb`hbNN */

/*-----------------------------------------------------------------
// foCX
//---------------------------------------------------------------*/

#define UD332_CCH_VEN                   8
#define UD332_CCH_DEV                   16
#define UD332_CCH_VER                   4

typedef struct
{
    unsigned short  cbCdb;              /* R}h\̂̃oCg */
    unsigned short  cbSdb;              /* Xe[^X\̂̃oCg */
    unsigned long   cbBuff;             /* obt@̃oCg */
    char    sVen[ UD332_CCH_VEN ];      /* Җ */
    char    sDev[ UD332_CCH_DEV ];      /* i */
    char    sVer[ UD332_CCH_VER ];      /* t@[EFAo[W */
} TUD332DI, *PUD332DI;

/*-----------------------------------------------------------------
// |[gĎ
//---------------------------------------------------------------*/

/* [h */
//#define UD332_MON_NONE                  0   /* ĎȂ */
//#define UD332_MON_ALT                   1   /* Ώۃrbgɕω */
//#define UD332_MON_AND                   2   /* ΏۃrbgSv */
//#define UD332_MON_OR                    3   /* Ώۃrbgv */

//typedef struct  /* |[gĎݒ̍\ */
//{
//    unsigned char   bMode;      /* [h */
//    unsigned char   bMask;      /* ĎΏۃrbg}XN */
//    unsigned char   bData;      /* f[^ */
//} TUD332TC, *PUD332TC;

#ifdef  WIN32   /*[*/

/*-----------------------------------------------------------------
// Gg
//---------------------------------------------------------------*/

        /* DLL [h */
BOOL WINAPI Ud332DllOpen( void );
        /* DLL  */
BOOL WINAPI Ud332DllClose( void );
        /* ŌɔG[̃R[h擾 */
DWORD WINAPI Ud332GetLastError( WORD pwLogDevice );
        /* DLLAhCõo[W擾 */
BOOL WINAPI Ud332GetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion );
        /* Cӂ̃foCX̎gp錾 */
BOOL WINAPI Ud332Create( PWORD pwLogDevice, HWND hwnd, UINT uWMCode );
        /* gp̃foCX */
BOOL WINAPI Ud332Close( WORD wLogDevice );
        /* foCX擾 */
BOOL WINAPI Ud332GetDevInfo( WORD wLogDevice, PUD332DI pDevInfo );
        /* [^[XCb`̒l擾 */
BOOL WINAPI Ud332GetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue );
        /* jbg^Cv擾 */
BOOL WINAPI Ud332GetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue );
        /* Cӂ̃|[gf[^ */
BOOL WINAPI Ud332InPort( WORD wLogDevice, DWORD dwLogPort, PBYTE pbInValue );
        /* Cӂ̃|[gփf[^o */
BOOL WINAPI Ud332OutPort( WORD wLogDevice, DWORD dwLogPort, BYTE bOutValue );

        /* EIb`hbN̐ݒ */
BOOL WINAPI Ud332SetWdt( WORD wLogDevice, BYTE bWdtValue );
        /* EIb`hbN̊Jn */
BOOL WINAPI Ud332ResetWdt( WORD wLogDevice );
        /* EIb`hbNo͐ݒ */
BOOL WINAPI Ud332SetDefaultOutput( WORD wLogDevice, DWORD dwLogPort, BYTE bDefaultValue );
        /* EIb`hbNtO */
BOOL WINAPI Ud332GetWdtStatus( WORD wLogDevice, PBYTE pbWdtStatus );

#endif  /*] WIN32 */

#ifdef __cplusplus
}
#endif

#endif  /*] CPIUD332_H */

