/*============================================================================
//  cpiud332s.c
//
//  CPI-UD332
//  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
//
//  Copyright (C) CPI Technologies, Inc.
//==========================================================================*/
#define STRICT
#include <windows.h>
#include <tchar.h>
#include "cpiud332.h"

const TCHAR szTitle[] = _T("Sample");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD iDev);
static  LPCTSTR str_err( ULONG iError );

/*============================================================================
//  vO̊Jn
//===========================================================================*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    WORD    iDev;               /* foCX̘_Xbgԍi[ */
    ULONG   dDll;               /* Dllo[W */
    ULONG   dDrv;               /* hCo[W */

    TUD332DI    di;             /* foCX̍\̕ϐ */
    ULONG   dVal;               /* [^[XCb`̒l */

    BYTE cbDat;                 /* o̓f[^ϐ */

    ULONG   get_err;

    TCHAR szBuf[512];

    ( void )hInstance;
    ( void )hPrevInstance;
    ( void )lpCmdLine;
    ( void )nCmdShow;

    /*-------------------------------------------------
    // DLL ̎gp錾
    //-----------------------------------------------*/
    if ( ! Ud332DllOpen() )
    {
        ResultMessage(_T("Ud332DllOpen error.\n"));
        get_err = GetLastError();
        wsprintf(szBuf, _T("Windows GetLastError\n\n") _T("Error code: %08lxh"),get_err);
        MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
        return 1;               /* ud332.dll ̃[hɎs܂ */
    }
    ResultMessage(_T("Ud332DllOpen succeeded.\n"));

    /*-------------------------------------------------
    // o[Wԍ\
    // CPI-UD332 DLL,hCo[̃o[Wԍ擾
    //-----------------------------------------------*/
    if ( ! Ud332GetVersion( &dDll, &dDrv ) )
    {
        ResultMessage(_T("Ud332GetVersion failed.\n\n"));
        get_err = GetLastError();
        wsprintf(szBuf, _T("Windows GetLastError\n\n") _T("Error code: %08lxh"),get_err);
        MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
        return 1;
    }
    wsprintf(szBuf, _T("GetVersion\n")
                    _T("DLL    Version\t: %08lxh\n")
                    _T("Driver Version\t: %08lxh"),
                    dDll,
                    dDrv);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // CPI-UD332̎gp錾
    //-----------------------------------------------*/
    iDev = UD332_DEVICE_AUTO;           /* gp̃foCXT܂B*/
    if ( ! Ud332Create( &iDev, NULL, 0 ) )
    {
        ErrorMessage(UD332_DEVICE_AUTO);
        get_err = GetLastError();
        wsprintf(szBuf, _T("Windows GetLastError\n\n") _T("Error code: %08lxh"),get_err);
        MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
        return 1;
    }
    wsprintf(szBuf, _T("CPI-UD332 Created\n\n")
            _T("Device # is: %2d"), iDev);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // \[X
    //-----------------------------------------------*/
    if ( ! Ud332GetDevInfo( iDev, &di ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("GetDevInfo\n\n")
                    _T("cbCdb : %u\n" )
                    _T("cbSdb : %u\n" )
                    _T("cbBuff: %lu\n" )
                    _T("sVen  : %.8hs\n" )
                    _T("sDev  : %.16hs\n" )
                    _T("sVer  : %.4hs\n\n" ),
                    di.cbCdb,
                    di.cbSdb,
                    di.cbBuff,
                    di.sVen,
                    di.sDev,
                    di.sVer);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // [^[XCb`̒l擾
    //-----------------------------------------------*/
    if ( ! Ud332GetSwitchValue( iDev, &dVal ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("GetSwitchValue\n\n")
                    _T("SW Val=0x%lX.\n"), dVal );
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port A 0xAÃf[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port A փf[^o (0xAA)"));
    cbDat = (BYTE)0xAA;           /* o̓f[^Zbg 0xAAh */
    if ( ! Ud332OutPort( iDev, UD332_PORT_A, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port A Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port A 0x00̃f[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port A փf[^o (0x00)"));
    cbDat = (BYTE)0x00;         /* o̓f[^Zbg 0x00h */
    if ( ! Ud332OutPort( iDev, UD332_PORT_A, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port A Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port B 0xBB̃f[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port B փf[^o (0xBB)"));
    cbDat = (BYTE)0xBB;           /* o̓f[^Zbg 0xBBh */
    if ( ! Ud332OutPort( iDev, UD332_PORT_B, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port B Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port B 0x00̃f[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port B փf[^o (0x00)"));
    cbDat = (BYTE)0x00;         /* o̓f[^Zbg 0x00h */
    if ( ! Ud332OutPort( iDev, UD332_PORT_B, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port B Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port C 0xCC̃f[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port C փf[^o (0xCC)"));
    cbDat = (BYTE)0xCC;           /* o̓f[^Zbg 0xCCh */
    if ( ! Ud332OutPort( iDev, UD332_PORT_C, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port C Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port C 0x00̃f[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port C փf[^o (0x00)"));
    cbDat = (BYTE)0x00;         /* o̓f[^Zbg 0x00h */
    if ( ! Ud332OutPort( iDev, UD332_PORT_C, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port C Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port D 0xDD̃f[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port D փf[^o (0xDD)"));
    cbDat = (BYTE)0xDD;           /* o̓f[^Zbg 0xDDh */
    if ( ! Ud332OutPort( iDev, UD332_PORT_D, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port D Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // Port D 0x00̃f[^o
    //-----------------------------------------------*/
    ResultMessage(_T("Port D փf[^o (0x00)"));
    cbDat = (BYTE)0x00;         /* o̓f[^Zbg 0x00h */
    if ( ! Ud332OutPort( iDev, UD332_PORT_D, cbDat ) )
    {
        ErrorMessage(iDev);
        return 1;
    }
    wsprintf(szBuf, _T("o͊\n")
                    _T("Port D Out Data: %02xh"), cbDat);
    ResultMessage(szBuf);

    /*-------------------------------------------------
    // CPI-UD332̎gpJ
    //-----------------------------------------------*/
    if ( ! Ud332Close( iDev ) )
    {
        ErrorMessage( iDev );
        return 1;
    }
    ResultMessage(_T("CPI-UD332 Closed"));

    /*-------------------------------------------------
    // UD332.dll ̎gpJ
    //-----------------------------------------------*/
    if ( ! Ud332DllClose() )
    {
        ErrorMessage( iDev );
        return 1;
    }
    ResultMessage( _T( "DllClose succeeded.\n\n" ) );
    return 0;
}

/*============================================================================
// ʂ\
//===========================================================================*/
static void ResultMessage(LPCTSTR lpszbuf)
{
    MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

/*============================================================================
// G[bZ[W\
//===========================================================================*/
static void ErrorMessage(WORD iDev)
{

    ULONG   rd;
    TCHAR szBuf[50];

    rd = Ud332GetLastError( iDev );

    wsprintf(szBuf, _T("GetLastError\n\n")
        _T("Error code: %08lxh %s "),rd, str_err( rd ));
    MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}

static  LPCTSTR str_err( ULONG iError )
{
    switch ( iError )
    {
    default:
        break;
    case UD332_SUCCESS:
        return _T( "Succeeded" );
    case UD332_ERR_SYSTEM:
        return _T( "System error occured" );
    case UD332_ERR_NO_DEVICE:
        return _T( "Device not found" );
    case UD332_ERR_IN_USE:
        return _T( "Device is in use" );
    case UD332_ERR_INVALID_DEVICENO:
        return _T( "Invalid device number" );
    case UD332_ERR_INVALID_ARGUMENT:
        return _T( "Invalid argument" );
    case UD332_ERR_INVALID_PORT:
        return _T( "Invalid port number" );
    case UD332_ERR_DLL:
        return _T( "DLL not opened" );
    }
    return _T( "Unknown error" );
}
