/*======================================================================
//  cpiud332.c
//
//  Copyright (C) CPI Technologies, Inc.
//====================================================================*/
#include <windows.h>
#include <tchar.h>
#include <assert.h>
#include "cpiud332.h"

/*======================================================================
// Macro
//====================================================================*/
#define SZ_DLL          _T( "CPIUD332.DLL" )

/*======================================================================
// Type
//====================================================================*/
typedef struct
{
            /*
            // NCAgĂяoGg
            // GetProcAddress ̃GgAɎsGg
            // ǂ炩ł
            */
    FARPROC         pfn;
    FARPROC const   pfnInv; /* ɎsGg */
    LPCSTR const    psz;    /* GNX|[g */
}   TFEE;
typedef struct
{
    TFEE    GetLastError;
    TFEE    GetVersion;
    TFEE    Create;
    TFEE    Close;
    TFEE    GetDevInfo;
    TFEE    GetSwitchValue;
    TFEE    GetUnitType;
    TFEE    OutPort;
    TFEE    done;
    TFEE    init;
    TFEE    SetWdt;
    TFEE    ResetWdt;
    TFEE    SetDefaultOutput;
    TFEE    GetWdtStatus;
    TFEE    end_marker;         /* do NOT remove */
}   TDET;

/*======================================================================
// Statical function
//====================================================================*/
static  DWORD WINAPI InvGetLastError( WORD pwLogDevice );
static  INT_PTR WINAPI InvGetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion );

static  INT_PTR WINAPI InvCreate( PWORD pwLogDevice, HWND hwnd, UINT uWMCode );

static  INT_PTR WINAPI InvClose( WORD wLogDevice );
static  INT_PTR WINAPI InvGetDevInfo( WORD wLogDevice, PUD332DI pDevInfo );
static  INT_PTR WINAPI InvGetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue );
static  INT_PTR WINAPI InvGetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue );
static  INT_PTR WINAPI InvOutPort( WORD wLogDevice, DWORD dwLogPort, BYTE bOutValue );
static  INT_PTR WINAPI inv_done( void );
static  INT_PTR WINAPI inv_init( void );

static  INT_PTR WINAPI InvSetWdt( WORD wLogDevice, BYTE bWdtValue );
static  INT_PTR WINAPI InvResetWdt( WORD wLogDevice );
static  INT_PTR WINAPI InvSetDefaultOutput( WORD wLogDevice, DWORD dwLogPort, BYTE bDefaultValue );
static  INT_PTR WINAPI InvGetWdtStatus( WORD wLogDevice, PBYTE pbWdtStatus );

static  BOOL det_get( void );
static  void det_inv( void );

/*======================================================================
// Statical variable
//====================================================================*/
static  HMODULE s_hDll = NULL;
static  TDET s_det =
{
{   ( FARPROC )InvGetLastError,
            ( FARPROC )InvGetLastError,
            "Ud332GetLastError"
            },
{   InvGetVersion,      InvGetVersion,      "Ud332GetVersion" },
{   InvCreate,          InvCreate,          "Ud332Create" },
{   InvClose,           InvClose,           "Ud332Close" },
{   InvGetDevInfo,      InvGetDevInfo,      "Ud332GetDevInfo" },
{   InvGetSwitchValue,  InvGetSwitchValue,  "Ud332GetSwitchValue" },
{   InvGetUnitType,     InvGetUnitType,     "Ud332GetUnitType" },
{   InvOutPort,         InvOutPort,         "Ud332OutPort" },
{   inv_done,           inv_done,           "ud332_done" },
{   inv_init,           inv_init,           "ud332_init" },

{   InvSetWdt,          InvSetWdt,          "Ud332SetWdt" },
{   InvResetWdt,        InvResetWdt,        "Ud332ResetWdt" },
{   InvSetDefaultOutput,InvSetDefaultOutput,"Ud332SetDefaultOutput" },
{   InvGetWdtStatus,    InvGetWdtStatus,    "Ud332GetWdtStatus" },

{   NULL,               NULL,               NULL }
};

/*======================================================================
//      DLL [h
//      
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332DllOpen( void )
{
    if ( NULL != s_hDll )
    {
        return TRUE;                    /* [hς݂͐ */
    }
    s_hDll = LoadLibrary( SZ_DLL );
    if ( NULL == s_hDll )
    {
        return FALSE;
    }
    if ( ! det_get() )
    {
        ( void )Ud332DllClose();
        return FALSE;
    }
    return TRUE;
}
/*======================================================================
//      DLL 
//      
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332DllClose( void )
{
    if ( NULL == s_hDll )
    {
        return TRUE;                    /* Jς݂͐ */
    }

    det_inv();

    if ( ! FreeLibrary( s_hDll ) )
    {
        return FALSE;
    }

    s_hDll = NULL;

    return TRUE;
}
/*======================================================================
//      ŌɔG[̃R[h擾
//      iDev    G[foCX̘_foCXԍ
// ߂l   G[R[h
//====================================================================*/
DWORD WINAPI Ud332GetLastError( WORD pwLogDevice )
{
    assert( NULL != s_det.GetLastError.pfn );
    return ( DWORD )( *s_det.GetLastError.pfn )( pwLogDevice );
}
/*======================================================================
//      DLLAhCõo[Wԍ擾
//      pdwDllVersion
//                  DLL o[Wԍi[̈̃AhX
//          pdwDriverVersion
//                  hCoo[Wԍi[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332GetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion )
{
    assert( NULL != s_det.GetVersion.pfn );
    return ( BOOL )( *s_det.GetVersion.pfn )( pdwDllVersion, pdwDriverVersion );
}
/*======================================================================
//      Cӂ̃foCX̎gp錾
//      pwLogDevice gpfoCX̘_foCXԍi[AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332Create( PWORD pwLogDevice, HWND hwnd, UINT uWMCode )
{
    assert( NULL != s_det.Create.pfn );
    return ( BOOL )( *s_det.Create.pfn )( pwLogDevice, hwnd, uWMCode );
}
/*======================================================================
//      gp̃foCX
//      wLogDevice  foCX̘_foCXԍ
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332Close( WORD wLogDevice )
{
    assert( NULL != s_det.Close.pfn );
    return ( BOOL )( *s_det.Close.pfn )( wLogDevice );
}
/*======================================================================
//      wfoCX̃foCX擾
//      wLogDevice  foCX擾foCX̘_foCXԍ
//          pDevInfo    foCXi[\̂̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332GetDevInfo( WORD wLogDevice, PUD332DI pDevInfo )
{
    assert( NULL != s_det.GetDevInfo.pfn );
    return ( BOOL )( *s_det.GetDevInfo.pfn )( wLogDevice, pDevInfo );
}
/*======================================================================
//      [^[XCb`̒l擾
//      wLogDevice      l擾foCX̘_foCXԍ
//          pdwSwitchValue  li[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332GetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue )
{
    assert( NULL != s_det.GetSwitchValue.pfn );
    return ( BOOL )( *s_det.GetSwitchValue.pfn )( wLogDevice, pdwSwitchValue );
}
/*======================================================================
//      jbg^Cv̒l擾
//      wLogDevice       l擾foCX̘_foCXԍ
//          pdwUnitTypeValue li[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332GetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue )
{
    assert( NULL != s_det.GetUnitType.pfn );
    return ( BOOL )( *s_det.GetUnitType.pfn )( wLogDevice, pdwUnitTypeValue );
}
/*======================================================================
//      Cӂ̃|[gփf[^o
//      wLogDevice  o͂foCX̘_foCXԍ
//          dwLogPort   o͂_|[g
//          bOutValue   o͂f[^
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332OutPort( WORD wLogDevice, DWORD dwLogPort, BYTE bOutValue )
{
    assert( NULL != s_det.OutPort.pfn );
    return ( BOOL )( *s_det.OutPort.pfn )( wLogDevice, dwLogPort, bOutValue );
}
/*======================================================================
//      EIb`hbNJE^̐ݒ
//      wLogDevice    lݒ肷foCX̘_foCXԍ
//          dVal    JE^l (0`4)
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332SetWdt( WORD wLogDevice, BYTE bWdtValue )
{
    assert( NULL != s_det.SetWdt.pfn );
    return ( BOOL )( *s_det.SetWdt.pfn )( wLogDevice, bWdtValue );
}
/*======================================================================
//      EIb`hbÑJE^Zbg
//      iDev    lݒ肷foCX̘_foCXԍ
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332ResetWdt( WORD wLogDevice )
{
    assert( NULL != s_det.ResetWdt.pfn );
    return ( BOOL )( *s_det.ResetWdt.pfn )( wLogDevice );
}
/*======================================================================
//      EIb`hbNo͐ݒ
//      iDev    lݒ肷foCX̘_foCXԍ
//          dVal    JE^l (0`4)
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332SetDefaultOutput( WORD wLogDevice, DWORD dwLogPort, BYTE bDefaultValue )
{
    assert( NULL != s_det.SetDefaultOutput.pfn );
    return ( BOOL )( *s_det.SetDefaultOutput.pfn )( wLogDevice, dwLogPort, bDefaultValue );
}
/*======================================================================
//      EIb`hbNtO擾
//      iDev    l擾foCX̘_foCXԍ
//          pbVal   EIb`hbNtOԂi[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud332GetWdtStatus( WORD wLogDevice, PBYTE pbWdtStatus )
{
    assert( NULL != s_det.GetWdtStatus.pfn );
    return ( BOOL )( *s_det.GetWdtStatus.pfn )( wLogDevice, pbWdtStatus );
}

/*----------------------------------------------------------------------
// ɎsGg
//--------------------------------------------------------------------*/
static  DWORD WINAPI InvGetLastError( WORD pwLogDevice )
{
    ( void )pwLogDevice;
    return UD332_ERR_DLL;
}
static  INT_PTR WINAPI InvGetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion )
{
    ( void )pdwDllVersion;
    ( void )pdwDriverVersion;
    return FALSE;
}
static  INT_PTR WINAPI InvCreate( PWORD pwLogDevice, HWND hwnd, UINT uWMCode  )
{
    ( void )pwLogDevice;
    ( void )hwnd;
    ( void )uWMCode;
    return FALSE;
}
static  INT_PTR WINAPI InvClose( WORD wLogDevice )
{
    ( void )wLogDevice;
    return FALSE;
}
static  INT_PTR WINAPI InvGetDevInfo( WORD wLogDevice, PUD332DI pDevInfo )
{
    ( void )wLogDevice;
    ( void )pDevInfo;
    return FALSE;
}
static  INT_PTR WINAPI InvGetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue )
{
    ( void )wLogDevice;
    ( void )pdwSwitchValue;
    return FALSE;
}
static  INT_PTR WINAPI InvGetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue )
{
    ( void )wLogDevice;
    ( void )pdwUnitTypeValue;
    return FALSE;
}
static  INT_PTR WINAPI InvOutPort(WORD wLogDevice, DWORD dwLogPort, BYTE bOutValue )
{
    ( void )wLogDevice;
    ( void )dwLogPort;
    ( void )bOutValue;
    return FALSE;
}
static  INT_PTR WINAPI inv_done( void )
{
    return FALSE;
}
static  INT_PTR WINAPI inv_init( void )
{
    return FALSE;
}
static  INT_PTR WINAPI InvSetWdt( WORD wLogDevice, BYTE bWdtValue )
{
    ( void )wLogDevice;
    ( void )bWdtValue;
    return FALSE;
}
static  INT_PTR WINAPI InvResetWdt( WORD wLogDevice )
{
    ( void )wLogDevice;
    return FALSE;
}
static  INT_PTR WINAPI InvSetDefaultOutput( WORD wLogDevice, DWORD dwLogPort, BYTE bDefaultValue )
{
    ( void )wLogDevice;
    ( void )dwLogPort;
    ( void )bDefaultValue;
    return FALSE;
}
static  INT_PTR WINAPI InvGetWdtStatus( WORD wLogDevice, PBYTE pbWdtStatus )
{
    ( void )wLogDevice;
    ( void )pbWdtStatus;
    return FALSE;
}

/*----------------------------------------------------------------------
//      Gg擾
//      
// ߂l    TRUE
//          s FALSE
//--------------------------------------------------------------------*/
static  BOOL det_get( void )
{
    TFEE*   pfe;

    for ( pfe = ( TFEE* )&s_det; NULL != pfe->psz; pfe++ )
    {
        pfe->pfn = GetProcAddress( s_hDll, pfe->psz );
        if ( NULL == pfe->pfn )
        {
            pfe->pfn = pfe->pfnInv;

            return FALSE;
        }
    }

    assert( NULL != s_det.init.pfn );

    return ( BOOL )( *s_det.init.pfn )();
}
/*----------------------------------------------------------------------
//      Gg
//      
// ߂l    TRUE
//          s FALSE
//--------------------------------------------------------------------*/
static  void det_inv( void )
{
    TFEE*   pfe;

    assert( NULL != s_det.done.pfn );
    ( void )( *s_det.done.pfn )();

    for ( pfe = ( TFEE* )&s_det; NULL != pfe->psz; pfe++ )
    {
        pfe->pfn = pfe->pfnInv;
    }
}
